package com.kingdee.eas.custom.synctask.task;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.metadata.data.SortType;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.affair.IResignBizBillEntry;
import com.kingdee.eas.hr.affair.ResignBizBillEntryCollection;
import com.kingdee.eas.hr.affair.ResignBizBillEntryFactory;
import com.kingdee.eas.hr.affair.ResignBizBillEntryInfo;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.*;
import com.kingdee.eas.hr.emp.IPersonPosition;
import com.kingdee.eas.hr.emp.PersonPositionCollection;
import com.kingdee.eas.hr.emp.PersonPositionFactory;
import com.kingdee.eas.hr.emp.PersonPositionInfo;
import com.kingdee.eas.scm.util.datetime.DateTimeUtil;
import oadd.org.apache.commons.codec.digest.DigestUtils;
import okhttp3.*;
import org.apache.log4j.Logger;

import javax.ejb.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.*;
import java.util.concurrent.TimeUnit;

import com.kingdee.bos.*;
import com.kingdee.bos.util.BOSObjectType;
import com.kingdee.bos.metadata.IMetaDataPK;
import com.kingdee.bos.metadata.rule.RuleExecutor;
import com.kingdee.bos.metadata.MetaDataPK;
//import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.framework.ejb.AbstractEntityControllerBean;
import com.kingdee.bos.framework.ejb.AbstractBizControllerBean;
//import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.bos.service.IServiceContext;


public class SynPersonToPunchCardFacadeControllerBean extends AbstractSynPersonToPunchCardFacadeControllerBean {
    private static Logger logger =
            Logger.getLogger("com.kingdee.eas.custom.synctask.task.SynPersonToPunchCardFacadeControllerBean");
    private volatile Properties propt;  // ʹ volatile ֤ɼ
    private final Object configLock = new Object();
    private static final OkHttpClient client = new OkHttpClient.Builder()
            .connectTimeout(30, TimeUnit.SECONDS)
            .readTimeout(30, TimeUnit.SECONDS)
            .build();

    private void loadProperties() throws BOSException {
        if (propt == null) {  // һμ
            synchronized (configLock) {
                if (propt == null) {  // ڶμ飨˫ؼ
                    Properties temp = new Properties();
                    String path = System.getProperty("EAS_HOME") + "/server/properties/abk/syncAtsConfig.properties";
                    try (FileInputStream fis = new FileInputStream(path)) {  // try-with-resources Զر
                        temp.load(fis);
                        propt = temp;  // ԭԸֵ
                    } catch (IOException e) {
                        String errorMsg = "ļʧ: " + path + " | " + e.getMessage();
                        logger.error(errorMsg, e);  // ʹ־¼ e.printStackTrace()
                        throw new BOSException(errorMsg);
                    }
                }
            }
        }
    }


    /**
     * Աְ
     *
     * @param ctx
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _dimissionPerson(Context ctx, String personNumbers) throws BOSException, EASBizException {
        logger.error("_dimissionPerson--");
        loadProperties();
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        //ְ
        SelectorItemCollection sic = getSic();
        FilterInfo filterInfo = new FilterInfo();
        if (personNumbers.equals(null) || personNumbers.equals("")) {
            throw new BOSException("ͬԱ벻Ϊգ");
        }
        filterInfo.getFilterItems().add(new FilterItemInfo("person.number", AtsUtil.toSet(personNumbers), CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        PersonPositionCollection personPositionCollection = iPersonPosition.getPersonPositionCollection(entityViewInfo);
        if (personPositionCollection.size() <= 1) {
            logger.error("personPositionCollection--" + personPositionCollection.size());
            List<PersonPositionInfo> PersonPositionList = new ArrayList();
            for (int i = 0; i < personPositionCollection.size(); i++) {
                PersonPositionList.add(personPositionCollection.get(i));
            }
            logger.error("PersonPositionList--" + PersonPositionList.size());
            JSONArray msgArray = new JSONArray();
            Map messageMap = null;
            if (PersonPositionList.size() > 180) {
                List<PersonPositionCollection> objects = splitList(PersonPositionList, 180);
                for (int i = 0; i < objects.size(); i++) {
                    PersonPositionCollection coll = objects.get(i);
                    personDelete(ctx, coll);
                }
            } else {
                personDelete(ctx, personPositionCollection);
                msgArray.add(messageMap);
            }
        }
    }

    /**
     * Աɾ
     *
     * @param ctx
     * @param personPositionCollection
     * @throws BOSException
     */
    public void personDelete(Context ctx, PersonPositionCollection personPositionCollection) throws BOSException {
        logger.error("personDelete--");
        //ְ
        IResignBizBillEntry iResignBizBillEntry = ResignBizBillEntryFactory.getLocalInstance(ctx);
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
            PersonInfo person = personPositionInfo.getPerson();
            EmployeeTypeInfo employeeType = person.getEmployeeType();
            //жǷְԱ
            String number = employeeType.getNumber();
            logger.error("person--" + person.getName() + "--employeeType--" + number);
            if (number.equals("010") || number.equals("009") || number.equals("S09")) {
                //Աְ
                JSONObject result = synLeavePerson(iResignBizBillEntry, person);
                logger.error("personDelete--" + result);
            }
        }
    }

    /**
     * Աָ
     *
     * @param ctx
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _recoverPerson(Context ctx, int offSet) throws BOSException, EASBizException {
        logger.error("_recoverPerson--");
        loadProperties();
        String dayBefore = getDayBefore(new Date(), offSet);
        logger.error("_recoverPerson--dayBefore--" + dayBefore);
        //Ա䶯¼
        IEmpPosOrgRelation iEmpPosOrgRelation = EmpPosOrgRelationFactory.getLocalInstance(ctx);
        Set personSet = getPersonDateByDate(ctx, dayBefore);
        logger.error("_recoverPerson--personSet--" + dayBefore);
        //ѯֶ
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("id");
        sic.add("number");
        sic.add("person.id");
        sic.add("person.number");
        sic.add("action.id");
        sic.add("action.number");

        //
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("person", personSet, CompareType.INCLUDE));

        //
        SorterItemCollection sorter = new SorterItemCollection();
        SorterItemInfo sorterItem = new SorterItemInfo("createTime");
        sorterItem.setSortType(SortType.DESCEND);
        sorter.add(sorterItem);

        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, sorter);
        //ѯ䶯¼Ƿְ
        JSONArray personNumber = new JSONArray();
        EmpPosOrgRelationCollection empPosOrgRelationCollection = iEmpPosOrgRelation.getEmpPosOrgRelationCollection(entityViewInfo);
        for (int i = 0; i < empPosOrgRelationCollection.size(); i++) {
            EmpPosOrgRelationInfo empPosOrgRelationInfo = empPosOrgRelationCollection.get(i);
            //䶯
            String actionNumebr = empPosOrgRelationInfo.getAction().getNumber();
            //䶯ְ ִԱָ
            if (actionNumebr.equals("SHR02")) {
                personNumber.add(empPosOrgRelationInfo.getPerson().getNumber());
            }
        }
        logger.error("personNumber--" + personNumber);
        if (personNumber.size() > 0) {
            JSONObject params = new JSONObject();
            params.put("userpin", personNumber); //Ա
            //  Token  URL 
            long currentTime = Instant.now().getEpochSecond();
            String secretKey = propt.getProperty("SECRET_KEY");
            String token = DigestUtils.md5Hex(secretKey + currentTime);
            // ѯ
            Map<String, String> queryParams = new HashMap<>();
            queryParams.put("timestamp", String.valueOf(currentTime));
            queryParams.put("token", token);
            // ýӿ
            String urlPath = propt.getProperty("recoverUrlPath");
            String result = sendPostRequest(urlPath, params, queryParams);
            logger.error("result--" + result);
        }


    }

    /***
     * ȡʱڵԱID
     * @param ctx
     * @param dayBefore
     * @throws BOSException
     */
    private Set getPersonDateByDate(Context ctx, String dayBefore) throws BOSException {
        //Ա
        IPerson iPerson = PersonFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("hireDate", dayBefore, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("hireDate", new Date(), CompareType.LESS_EQUALS));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, null, null);
        logger.error("filterInfo--" + filterInfo.toSql());
        //ȡʱεԱ
        PersonCollection personCollection = iPerson.getPersonCollection(entityViewInfo);
        logger.error("personCollection--" + personCollection.size());
        Set personSet = new HashSet();
        for (int i = 0; i < personCollection.size(); i++) {
            PersonInfo personInfo = personCollection.get(i);
            personSet.add(personInfo.getId());
        }
        return personSet;
    }


    /**
     * ǰƶ
     *
     * @param specifiedDay
     * @param x
     * @return
     */
    public String getDayBefore(Date specifiedDay, int x) {
        Calendar c = Calendar.getInstance();
        Date date = specifiedDay;
        c.setTime(date);
        int day = c.get(Calendar.DATE);
        c.set(Calendar.DATE, day - x);    //ǰƼ
        //c.set(Calendar.DATE, day + x);  Ƽ

        String dayBefore = new SimpleDateFormat("yyyy-MM-dd").format(c.getTime());
        //System.out.println(dayBefore);
        return dayBefore;
    }

    /**
     * ͬԱ
     *
     * @param ctx
     * @param personNumbers
     * @throws BOSException
     * @throws EASBizException
     */
    @Override

    protected void _updatePerson(Context ctx, String personNumbers) throws BOSException, EASBizException {
        logger.error("_updatePerson--");
        loadProperties();
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        //ְ
        SelectorItemCollection sic = getSic();
        FilterInfo filterInfo = new FilterInfo();
        if (personNumbers.equals(null) || personNumbers.equals("")) {
            throw new BOSException("ͬԱ벻Ϊգ");
        }
        filterInfo.getFilterItems().add(new FilterItemInfo("person.number", AtsUtil.toSet(personNumbers), CompareType.INCLUDE));
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        PersonPositionCollection personPositionCollection = iPersonPosition.getPersonPositionCollection(entityViewInfo);
        logger.error("personPositionCollection--" + personPositionCollection.size());
        List<PersonPositionInfo> PersonPositionList = new ArrayList();
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionList.add(personPositionCollection.get(i));
        }
        logger.error("PersonPositionList--" + PersonPositionList.size());
        JSONArray msgArray = new JSONArray();
        Map messageMap = null;
        if (PersonPositionList.size() > 180) {
            List<PersonPositionCollection> objects = splitList(PersonPositionList, 180);
            for (int i = 0; i < objects.size(); i++) {
                PersonPositionCollection coll = objects.get(i);
                messageMap = updateSynPersonData(coll);
                msgArray.add(messageMap);
            }
        } else {
            messageMap = updateSynPersonData(personPositionCollection);
            msgArray.add(messageMap);
        }
        //Map messageMap = synPersonData(personPositionCollection, iResignBizBillEntry);
        logger.error("msgArray--" + msgArray);
    }

    /**
     * Ա-߼
     *
     * @param personPositionCollection
     * @return
     * @throws BOSException
     */
    private Map updateSynPersonData(PersonPositionCollection personPositionCollection) throws BOSException {
        logger.error("updateSynPersonData--");
        Map messageMap = new HashMap();
        //Ա
        JSONArray params = new JSONArray();
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
            PersonInfo person = personPositionInfo.getPerson();
            EmployeeTypeInfo employeeType = person.getEmployeeType();
            //жǷְԱ
            String number = employeeType.getNumber();
            logger.error("person--" + person.getName() + "--employeeType--" + number);
            if (!number.equals("010") && !number.equals("009") && !number.equals("S09")) {
                // 壨Զʱ䷶Χ
                JSONObject param = new JSONObject();
                param.put("name", person.getName()); //Ա
                param.put("pin", person.getNumber()); //Ա
                param.put("deptnumber", "1");  //ű
                params.add(param);
            }
        }
        logger.error("updateSynPersonData--params--" + params);
        if (params.size() > 0) {
            //Ա
            String response = synPerson(params);
            // Ӧ
            if (response != null) {
                messageMap.put("updatePersonMsg", response);
            }
        }
        return messageMap;
    }

    /**
     * Աʼ
     *
     * @param ctx
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _initializePerson(Context ctx) throws BOSException {
        logger.error("_initializePerson--");
        loadProperties();
        IPersonPosition iPersonPosition = PersonPositionFactory.getLocalInstance(ctx);
        //ְ
        IResignBizBillEntry iResignBizBillEntry = ResignBizBillEntryFactory.getLocalInstance(ctx);
        //ȡѯ
        SelectorItemCollection sic = getSic();
        EntityViewInfo entityViewInfo = EntityViewInfo.getInstance(null, sic, null);
        PersonPositionCollection personPositionCollection = iPersonPosition.getPersonPositionCollection(entityViewInfo);
        logger.error("personPositionCollection--" + personPositionCollection.size());
        List<PersonPositionInfo> PersonPositionList = new ArrayList();
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionList.add(personPositionCollection.get(i));
        }
        logger.error("PersonPositionList--" + PersonPositionList.size());
        JSONArray msgArray = new JSONArray();
        Map messageMap = null;
        if (PersonPositionList.size() > 180) {
            List<PersonPositionCollection> objects = splitList(PersonPositionList, 180);
            for (int i = 0; i < objects.size(); i++) {
                PersonPositionCollection coll = objects.get(i);
                messageMap = initializeSynPersonData(coll, iResignBizBillEntry);
                msgArray.add(messageMap);
            }
        } else {
            messageMap = initializeSynPersonData(personPositionCollection, iResignBizBillEntry);
            msgArray.add(messageMap);
        }
        //Map messageMap = synPersonData(personPositionCollection, iResignBizBillEntry);
        logger.error("msgArray--" + msgArray);
    }

    /**
     * ʼͬԱ
     *
     * @param personPositionCollection
     * @param iResignBizBillEntry
     * @return
     * @throws BOSException
     */
    private Map initializeSynPersonData(PersonPositionCollection personPositionCollection, IResignBizBillEntry iResignBizBillEntry) throws BOSException {
        Map messageMap = new HashMap();
        //Ա
        JSONArray params = new JSONArray();
        //Աְ
        JSONArray leavePersonMsg = new JSONArray();
        List<PersonInfo> deletePersonList = new ArrayList();
        for (int i = 0; i < personPositionCollection.size(); i++) {
            PersonPositionInfo personPositionInfo = personPositionCollection.get(i);
            PersonInfo person = personPositionInfo.getPerson();
            EmployeeTypeInfo employeeType = person.getEmployeeType();
            //жǷְԱ
            String number = employeeType.getNumber();
            logger.error("person--" + person.getName() + "--employeeType--" + number);
            if (number.equals("010") || number.equals("009") || number.equals("S09")) {
                //ְԱ
                deletePersonList.add(person);
            } else {
                // 壨Զʱ䷶Χ
                JSONObject param = new JSONObject();
                param.put("name", person.getName()); //Ա
                param.put("pin", person.getNumber()); //Ա
                param.put("deptnumber", "1");  //ű
                params.add(param);
            }
        }
        messageMap.put("leavePersonMsg", leavePersonMsg.toString());
        if (params.size() > 0) {
            //Ա
            String response = synPerson(params);
            // Ӧ
            if (response != null) {
                messageMap.put("updatePersonMsg", response);
            }
        }
        //ԱٸְԱ
        for (int i = 0; i < deletePersonList.size(); i++) {
            PersonInfo person = deletePersonList.get(i);
            //Աְ
            JSONObject result = synLeavePerson(iResignBizBillEntry, person);
            if (result != null) {
                leavePersonMsg.add(result);
            }
        }
        return messageMap;
    }


    /**
     * ѯ
     */
    public SelectorItemCollection getSic() {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("person.number");
        sic.add("person.name");
        sic.add("person.id");
        sic.add("person.hireDate");
        sic.add("person.nCell");
        sic.add("person.gender");
        sic.add("person.email");
        sic.add("person.employeeType.number");
        sic.add("personDep.name");
        sic.add("personDep.number");
        sic.add("personDep.id");
        sic.add("personDep.parent.id");
        return sic;
    }

    /**
     * ָ
     *
     * @param coll
     * @param len
     * @return
     */
    public List<PersonPositionCollection> splitList(List coll, int len) {
        List<PersonPositionCollection> result = new ArrayList();
        int size = coll.size();
        int count = (size + len - 1) / len;
        for (int i = 0; i < count; i++) {
            PersonPositionCollection personPositionCollection = new PersonPositionCollection();
            List<PersonPositionInfo> subList = coll.subList(i * len, ((i + 1) * len > size) ? size : (len * (i + 1)));
            for (int p = 0; p < subList.size(); p++) {
                PersonPositionInfo personPositionInfo = subList.get(p);
                personPositionCollection.add(personPositionInfo);
            }
            result.add(personPositionCollection);
        }
        return result;

    }


    /**
     * Աְ
     *
     * @param personInfo
     */
    public JSONObject synLeavePerson(IResignBizBillEntry iResignBizBillEntry, PersonInfo personInfo) throws BOSException {
        logger.error("synLeavePerson-----");
        ResignBizBillEntryCollection entryInfo = iResignBizBillEntry.getResignBizBillEntryCollection("where person.id = '" + personInfo.getId() + "'");
        JSONObject param = new JSONObject();
        if (entryInfo.size() > 0) {
            ResignBizBillEntryInfo resignBizBillEntryInfo = entryInfo.get(0);
            Date bizDate = resignBizBillEntryInfo.getBizDate();
            param.put("pin", personInfo.getNumber()); //Ա
            param.put("leavedate", DateTimeUtil.getFmtDate(bizDate, "yyyy-MM-dd HH:mm")); //ְ
            param.put("leavetype", 0); //Ա
        }
        //  Token  URL 
        long currentTime = Instant.now().getEpochSecond();
        String secretKey = propt.getProperty("SECRET_KEY");
        String token = DigestUtils.md5Hex(secretKey + currentTime);
        // ѯ
        Map<String, String> queryParams = new HashMap<>();
        queryParams.put("timestamp", String.valueOf(currentTime));
        queryParams.put("token", token);
        // ýӿ
        String urlPath = propt.getProperty("leaveUrlPath");
        String response = sendPostRequest(urlPath, param, queryParams);
        // Ӧ
        if (response != null) {
            JSONObject result = JSONObject.parseObject(response);
            if ("0".equals(result.getString("ret"))) {
                logger.error(personInfo.getId() + "_" + personInfo.getName() + "result--" + result);
            }
            return result;
        }
        return null;
    }

    /**
     * Ա
     *
     * @param params
     * @return
     */
    private String synPerson(JSONArray params) {
        //  Token  URL 
        long currentTime = Instant.now().getEpochSecond();
        String secretKey = propt.getProperty("SECRET_KEY");
        String token = DigestUtils.md5Hex(secretKey + currentTime);
        // ѯ
        Map<String, String> queryParams = new HashMap<>();
        queryParams.put("timestamp", String.valueOf(currentTime));
        queryParams.put("token", token);
        // ýӿ
        String urlPath = propt.getProperty("updateUrlPath");
        return sendPostRequest(urlPath, params, queryParams);
    }

    /**
     *  POST JSON ʽ
     *
     * @param urlPath     ӿڵַɺ· `/api/v2/transaction/get`
     * @param params      JSON 
     * @param queryParams URL ѯ `timestamp`  `token`
     * @return Ӧַʧܷ null
     */
    public static String sendPostRequest(String urlPath, JSONArray params, Map<String, String> queryParams) {
        try {
            // 1.  URLѯ
            HttpUrl.Builder urlBuilder = HttpUrl.parse(urlPath).newBuilder();
            if (queryParams != null) {
                queryParams.forEach(urlBuilder::addQueryParameter);
            }
            String fullUrl = urlBuilder.build().toString();

            // 2. 
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());

            // 3. 
            Request request = new Request.Builder()
                    .url(fullUrl)
                    .post(body)
                    .addHeader("Content-Type", "application/json")
                    .build();

            // 4. 󲢴Ӧ
            try (Response response = client.newCall(request).execute()) {
                if (response.isSuccessful() && response.body() != null) {
                    return response.body().string();
                } else {
                    logger.error("ʧܣ״̬: " + response.code());
                }
            }
        } catch (IOException e) {
            logger.error("쳣: " + e.getMessage(), e);
        }
        return null;
    }

    /**
     *  POST JSON ʽ
     *
     * @param urlPath     ӿڵַɺ· `/api/v2/transaction/get`
     * @param params      JSON 
     * @param queryParams URL ѯ `timestamp`  `token`
     * @return Ӧַʧܷ null
     */
    public static String sendPostRequest(String urlPath, JSONObject params, Map<String, String> queryParams) {
        try {
            // 1.  URLѯ
            HttpUrl.Builder urlBuilder = HttpUrl.parse(urlPath).newBuilder();
            if (queryParams != null) {
                queryParams.forEach(urlBuilder::addQueryParameter);
            }
            String fullUrl = urlBuilder.build().toString();

            // 2. 
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());

            // 3. 
            Request request = new Request.Builder()
                    .url(fullUrl)
                    .post(body)
                    .addHeader("Content-Type", "application/json")
                    .build();

            // 4. 󲢴Ӧ
            try (Response response = client.newCall(request).execute()) {
                if (response.isSuccessful() && response.body() != null) {
                    return response.body().string();
                } else {
                    logger.error("ʧܣ״̬: " + response.code());
                }
            }
        } catch (IOException e) {
            logger.error("쳣: " + e.getMessage(), e);
        }
        return null;
    }


}
