package com.kingdee.eas.custom.dormitorysystem.application.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.BOSObjectFactory;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.AbstractObjectCollection;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.org.HROrgUnitInfo;
import com.kingdee.eas.basedata.person.Genders;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryFactory;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo;
import com.kingdee.eas.custom.dormitorysystem.dormitory.IDormitory;
import com.kingdee.eas.custom.dormitorysystem.enumerationset.DormitoryClassification;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.DormitoryTypeInfo;
import com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.CoreBillBaseCollection;
import com.kingdee.eas.framework.ICoreBillBase;
import com.kingdee.eas.hr.ats.AtsUtil;
import com.kingdee.eas.hr.base.HRBillBaseEntryInfo;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.shr.base.syssetting.BasicItemStateEnum;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.util.DateTimeUtils;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.*;


/**
 * @author qingwu
 * @date 2025/4/27
 * @apiNote ABK_뵥
 */
public class RoomChangeApplicationEditHandler extends HRBillBaseEditHandler {
    private Logger logger = Logger.getLogger(RoomChangeApplicationEditHandler.class);
    private Context ctx = SHRContext.getInstance().getContext();

    @Override
    protected void beforeSubmit(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model) throws SHRWebException {
        logger.error("beforeSubmit--");
        HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) model;
        //String billIds = hrBillBaseInfo.getId().toString();
        //Map result = null;
        //try {
        //    //result = validateRoomAvailableByBillIds(billIds);
        //} catch (Exception e) {
        //    logger.error(e);
        //    throw new ShrWebBizException("÷validateRoomAvailableByBillIds: " + e.getMessage());
        //}
        //Integer code = (Integer) result.get("code");
        //if (500 == code) {
        //    List<String> errorMsgList = (List<String>) result.get("errorMsg");
        //    StringBuilder errorMsgBuilder = new StringBuilder();
        //    for (String errorMsg : errorMsgList) {
        //        errorMsgBuilder.append(errorMsg).append("\n");
        //    }
        //    throw new ShrWebBizException(errorMsgBuilder.toString());
        //}
        ////õ״̬Ϊδ
        //model.setInt("billState", 1);
        super.beforeSubmit(request, response, model);
    }

    public Map validateRoomAvailableByBillIds(String billIds) throws BOSException {
        logger.error("validateRoomAvailableByBillIds--");
        if (StringUtils.isEmpty(billIds)) {
            logger.error("idΪ!");
            throw new BOSException("idΪ!");
        }
        Map<String, List<Map<String, Date>>> roomListMap = new HashMap<String, List<Map<String, Date>>>();
        //StringBuilder errorMsg = new StringBuilder();
        List<String> errorMsgList = new ArrayList<String>();
        // HRBillBaseFactory.getLocalInstance()
        ICoreBillBase iCoreBillBase = (ICoreBillBase) BOSObjectFactory.createBOSObject(ctx,
                BOSUuid.read(billIds.split(",")[0]).getType());
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.person.*");
        sic.add("entrys.person.personType.*");
        sic.add("entrys.adjustRoom.*");
        sic.add("entrys.adjustRoom.DormitoryType.*");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("id", AtsUtil.toSet(billIds), CompareType.INCLUDE));
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CoreBillBaseCollection hrBillBaseCollection = iCoreBillBase.getCoreBillBaseCollection(viewInfo);
        logger.error("hrBillBaseCollection--" + hrBillBaseCollection.size());
        for (int i = 0; i < hrBillBaseCollection.size(); i++) {
            HRBillBaseInfo hrBillBaseInfo = (HRBillBaseInfo) hrBillBaseCollection.get(i);
            //String billId = hrBillBaseInfo.getId().toString();
            String baseInfoNumber = hrBillBaseInfo.getNumber();
            String bosType = hrBillBaseInfo.getId().getType().toString();
            AbstractObjectCollection entrys = (AbstractObjectCollection) hrBillBaseInfo.get("entrys");
            logger.error("entrys--" + entrys.size());
            for (int j = 0; j < entrys.size(); j++) {
                try {
                    HRBillBaseEntryInfo entryInfo = (HRBillBaseEntryInfo) entrys.getObject(j);
                    Date checkInDate = null;
                    //B371AC0A ޵¼
                    if ("B371AC0A".equals(bosType)) {
                        //޵
                        checkInDate = entryInfo.getDate("checkInDate");
                    }
                    if (checkInDate == null) {
                        throw new BOSException("ڲΪ!");
                    }
                    //
                    Date checkoutDate = entryInfo.getDate("checkoutDate");
                    if (checkoutDate == null) {
                        throw new BOSException("ڲΪ!");
                    }
                    //Ա
                    PersonInfo personInfo = (PersonInfo) entryInfo.getObjectValue("person");
                    if (personInfo == null) {
                        throw new BOSException("ԱΪ!");
                    }
                    //
                    DormitoryInfo dormitory = (DormitoryInfo) entryInfo.getObjectValue("adjustRoom");
                    if (dormitory == null) {
                        throw new BOSException("䲻Ϊ!");
                    }
                    String roomId = dormitory.getId().toString();
                    //ס,Ա,Աѯѡ
                    //Ա
                    PersonDormitoryTypeInfo personType = (PersonDormitoryTypeInfo) personInfo.get("personType");
                    if (personType == null) {
                        throw new BOSException("Ա[" + personInfo.getName() + "]ԱΪգ뼰ʱά");
                    }
                    //String personTypeId = personType.getId().toString();
                    //ס
                    int dormCheckInCount = 0;
                    //1.У鷿Ϣ
                    validateDormitoryInfo(ctx, personInfo, dormitory);
                    //ס
                    int occupancyCapacity = dormitory.getOccupancyCapacity();
                    //2.ݻںסϢס
                    dormCheckInCount += getCheckInInfoByOccupants(ctx, checkInDate, checkoutDate, roomId, personType);
                    //3.ݻںס뵥״̬Ϊеס
                    dormCheckInCount += getCheckInInfoByCheckInApplication(ctx, checkInDate, checkoutDate, roomId, personType);
                    //4.ݻں뵥״̬Ϊеס
                    dormCheckInCount += getRoomChangeInfoByRoomChangeApplication(ctx, checkInDate, checkoutDate, roomId, personType);
                    //5.ݵǰס
                    if (roomListMap.containsKey(roomId)) {
                        List<Map<String, Date>> roomMapList = roomListMap.get(roomId);
                        for (int k = 0; k < roomMapList.size(); k++) {
                            Map<String, Date> roomMap = roomMapList.get(k);
                            Date checkInDateOld = roomMap.get("checkInDate");
                            Date checkoutDateOld = roomMap.get("checkoutDate");
                            //ססں֮
                            //ססں֮
                            if ((checkInDateOld.compareTo(checkInDate) <= 0 && checkoutDateOld.compareTo(checkInDate) >= 0)
                                    || (checkInDateOld.compareTo(checkInDate) >= 0 && checkInDateOld.compareTo(checkoutDate) <= 0)) {
                                dormCheckInCount++;
                            }
                        }
                    }
                    logger.error("occupancyCapacity--" + occupancyCapacity);
                    logger.error("dormCheckInCount--" + dormCheckInCount);
                    //6.ʣס: ס - ס
                    if (occupancyCapacity - dormCheckInCount < 0) {
                        String dormitoryName = dormitory.getName();
                        throw new BOSException("ǰס" + dormCheckInCount + "ѳ[" + dormitoryName + "]ס" + occupancyCapacity + "ס!");
                    }
                    Map roomMap = new HashMap();
                    roomMap.put("checkInDate", checkInDate);
                    roomMap.put("checkoutDate", checkoutDate);
                    if (roomListMap.containsKey(roomId)) {
                        roomListMap.get(roomId).add(roomMap);
                    } else {
                        List list = new ArrayList();
                        roomListMap.put(roomId, list);
                        list.add(roomMap);
                    }
                } catch (Exception e) {
                    logger.error("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage(), e);
                    errorMsgList.add("ݱΪ" + baseInfoNumber + "Уδͨ: " + e.getMessage());
                    //errorMsg.append("ݱΪ").append(baseInfoNumber).append("Уδͨ: ").append(e.getMessage()).append(System.lineSeparator());
                }
            }
        }
        Map result = new HashMap();
        if (errorMsgList.size() > 0) {
            result.put("code", 500);
            result.put("errorMsg", errorMsgList);
        } else {
            result.put("code", 200);
        }
        return result;
    }

    /**
     * סں뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getRoomChangeInfoByRoomChangeApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType
    ) throws BOSException {
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("adjustRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //סں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2,3", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("adjustRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        RoomChangeApplicationEntryCollection roomChangeApplicationEntryCol = iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < roomChangeApplicationEntryCol.size(); i++) {
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCol.get(i);
            //
            PersonInfo person = roomChangeApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * סںס뵥״̬Ϊеס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    private int getCheckInInfoByCheckInApplication(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType
    ) throws BOSException {
        ICheckInApplicationEntry iCheckInApplicationEntry = CheckInApplicationEntryFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("adjustRoom", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        //״̬
        filterItems.add(new FilterItemInfo("parent.billState", "1,2,3", CompareType.INCLUDE));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("adjustRoom.id");
        sic.add("person.personType.id");
        sic.add("person.personType.name");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        CheckInApplicationEntryCollection checkInApplicationEntryCol = iCheckInApplicationEntry.getCheckInApplicationEntryCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        for (int i = 0; i < checkInApplicationEntryCol.size(); i++) {
            CheckInApplicationEntryInfo checkInApplicationEntryInfo = checkInApplicationEntryCol.get(i);
            //
            PersonInfo person = checkInApplicationEntryInfo.getPerson();
            String personName = person.getName();
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = (PersonDormitoryTypeInfo) person.get("personType");
            if (personDormitoryType == null) {
                throw new BOSException("Ա[" + personName + "]ԱΪգ뼰ʱά");
            }
            String personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            //ۼס
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    /**
     * У鷿Ϣ
     *
     * @param ctx
     * @param personInfo
     * @param dormitory  
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    protected void validateDormitoryInfo(
            Context ctx,
            PersonInfo personInfo,
            DormitoryInfo dormitory
    ) throws BOSException, EASBizException {
        Genders gender = personInfo.getGender();
        if (gender == null) {
            throw new BOSException("ԱԱΪ!");
        }
        String personInfoName = personInfo.getName();
        IDormitory iDormitory = DormitoryFactory.getLocalInstance(ctx);
        //ѯϢ
        String dormitoryName = dormitory.getName();
        DormitoryClassification roomClassification = dormitory.getRoomClassification();
        if (!DormitoryClassification.ROOM.equals(roomClassification)) {
            String classificationAlias = roomClassification.getAlias();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + classificationAlias + "ס!");
        }
        BasicItemStateEnum dormitoryInfoState = dormitory.getState();
        if (BasicItemStateEnum.DISABLE.equals(dormitoryInfoState)) {
            throw new BOSException("[" + dormitoryName + "]δãס!");
        }
        //
        DormitoryTypeInfo dormitoryType = dormitory.getDormitoryType();
        Genders roomGender = dormitoryType.getGender();
        if (roomGender != null && gender.getValue() != roomGender.getValue()) {
            String dormitoryTypeName = dormitoryType.getName();
            throw new BOSException("[" + dormitoryName + "]Ϊ" + dormitoryTypeName + "Ա[" + personInfoName + "]Ա𲻷!");
        }
    }

    /**
     * סںסϢÿס
     *
     * @param ctx
     * @param checkInDate  ס
     * @param checkoutDate 
     * @param roomId       id
     * @param personType   Ա
     * @return
     * @throws BOSException
     */
    protected int getCheckInInfoByOccupants(
            Context ctx,
            Date checkInDate,
            Date checkoutDate,
            String roomId,
            PersonDormitoryTypeInfo personType
    ) throws BOSException {
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        //
        filterItems.add(new FilterItemInfo("Dormitory", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("checkoutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("checkInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("checkInDate", checkoutDate, CompareType.LESS_EQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) ");
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("PersonDormitoryType.id");
        sic.add("PersonDormitoryType.name");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
        OccupantsCollection occupantsCollection = iOccupants.getOccupantsCollection(viewInfo);
        String personTypeId = personType.getId().toString();
        String personTypeName = personType.getName();
        //ס
        int dormCheckInCount = 0;
        String personDormitoryTypeId = null;
        for (int i = 0; i < occupantsCollection.size(); i++) {
            OccupantsInfo occupantsInfo = occupantsCollection.get(i);
            //Ա
            PersonDormitoryTypeInfo personDormitoryType = occupantsInfo.getPersonDormitoryType();
            personDormitoryTypeId = personDormitoryType.getId().toString();
            String personDormitoryTypeName = personDormitoryType.getName();
            if (!personTypeId.equals(personDormitoryTypeId)) {
                throw new BOSException("Ա[" + personTypeName + "][" + personDormitoryTypeName + "]ס");
            }
            dormCheckInCount++;
        }
        return dormCheckInCount;
    }

    @Override
    protected void afterCreateNewModel(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo coreBaseInfo) throws SHRWebException {
        super.afterInitModel(request, response, coreBaseInfo);
        RoomChangeApplicationInfo roomChangeApplicationInfo = (RoomChangeApplicationInfo) coreBaseInfo;
        try {
            RoomChangeApplicationEntryCollection entrys = roomChangeApplicationInfo.getEntrys();
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = new RoomChangeApplicationEntryInfo();
            roomChangeApplicationEntryInfo.setCheckoutDate(DateTimeUtils.parseDate("2199-12-31", "yyyy-MM-dd"));
            //managementNotes  ˵
            StringBuilder managementNotes = new StringBuilder();
            managementNotes.append("Ը").append("\n");
            managementNotes.append("1Ծع˾ƶȡԱйع취˽Եʹλ").append("\n");
            managementNotes.append("2Ծάṫ𻵹Ծ⳥").append("\n");
            managementNotes.append("3ԾȫԼõˮ").append("\n");
            roomChangeApplicationInfo.setManagementNotes(managementNotes.toString());
            entrys.add(roomChangeApplicationEntryInfo);
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e);
        }
    }


}
